<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Chess Game Animation</title>
  <script src="https://d3js.org/d3.v7.min.js"></script>
  </head>
  <style>
    .modal {
      display: none;
      position: fixed;
      z-index: 1;
      left: 0;
      top: 0;
      width: 100%;
      height: 100%;
      overflow: auto;
      background-color: rgba(0,0,0,0.4);
    }

    .modal-content {
      background-color: #fefefe;
      margin: 3% auto;
      padding: 2%;
      border: 1px solid #888;
      width: 50%;
      height: 75%;
      font-family: "Arial";
    }

    .for-column{
      margin-top: 48px;
      flex-direction: column;
      display: flex;
    }

    .for-column-modal{
      padding-top: 10%;
      height: 70%;
      flex-direction: column;
      display: flex;
      justify-content: center;
      align-items: center;
    }

    .close {
      color: #aaa;
      float: right;
      font-size: 28px;
      font-weight: bold;
    }

    .close:hover,
    .close:focus {
      color: black;
      text-decoration: none;
      cursor: pointer;
    }

    #movesInput {
      height: 100%;
      width: 50%;
      margin-bottom: 100px;
      font-size: 16px;
      padding: 10px;
    }

    #adjust-title{
      padding-top: 1%;
    }

    #movesContainer {
      width: 600px;
      height: 534px;
      margin-left: 20px;
      margin-top: 4px;
      display: flex;
      flex-direction: row;
      border: 2px solid #000;
      padding: 10px;
      overflow-y: auto;
      background: linear-gradient(to right, white 50%, #C9883E 50%);
    }

    .white-moves{
      width: 50%;
    }
    .black-moves{
      width: 50%;
    }


    .white-moves li,
    .black-moves li {
      list-style: none;
      font-family: Arial;
      font-size:20;
      font-weight: bold;
      text-anchor: middle;
      padding-bottom: 5%;
    }

    .main-div{
      padding-left: 4%;
      display: flex;
      flex-direction: row;
    }   

    .main-button{
      width: 623px;
      margin-left: 20px;
    }

    li {
      cursor: default;
    }

    .hover:hover {
      cursor: pointer;
      font-size: 28px;
    }

    
  </style>
  <body>
    <div class="main-div">
      <div>
        <svg width="700" height="700"></svg>
      </div>
      <div class="for-column">
        <div>
            <button class="main-button" id="openModalBtn">Input Moves</button>
            <button class="main-button" id="startBtn">Start</button>  
        </div>
        <div id="movesContainer">
          <ul id="whiteMovesList" class="white-moves"></ul>
          <ul id="blackMovesList" class="black-moves"></ul>
        </div>
      </div>
    </div>
    <div id="myModal" class="modal">
      <div class="modal-content">
        <span class="close">&times;</span>
          <h2 id = "adjust-title">Enter Move List in this format: </h2>
          <div class ="for-column-modal">
            <textarea id="movesInput" placeholder="example: 1.d4 Nf6 2.c4 e6 3.Nf3 d5 4.g3 Be7 5.Bg2 O-O 6.O-O c6 7.Qc2 b6 8.Bf4 Bb7 9.Rd1 Nbd7 10.Ne5 Nh5 11.Bd2 Nhf6 12.Bf4 Nh5 13.Bd2 Nhf6 14.Bf4 ½-½&#10;&#10;www.365chess.com uses the correct format" rows="4"></textarea>
            <button id="saveMoveBtn">Save</button>
          </div>
      </div>
    </div>

  <script>
    const boardWidth = 600;
    const squareWidth = boardWidth / 8;
    const board = d3.select("svg")
    .attr("width", boardWidth + 100) 
    .attr("height", boardWidth + 100);

    const letters = "abcdefgh";

    let figures = 
    [
      ["♜", "♞", "♝", "♛", "♚", "♝", "♞", "♜"],
      ["♟", "♟", "♟", "♟", "♟", "♟", "♟", "♟"],
      ["", "", "", "", "", "", "", ""],
      ["", "", "", "", "", "", "", ""],
      ["", "", "", "", "", "", "", ""],
      ["", "", "", "", "", "", "", ""],
      ["♙", "♙", "♙", "♙", "♙", "♙", "♙", "♙"],
      ["♖", "♘", "♗", "♕", "♔", "♗", "♘", "♖"]
    ];
    let figuresStates =[];

    let whitePawns = [];
    let whiteRooks = [];
    let whiteKnights = [];
    let whiteBishops = [];
    let whiteQueen = [];
    let whiteKing = [];

    let blackPawns = [];
    let blackRooks = [];
    let blackKnights = [];
    let blackBishops = [];
    let blackQueen = [];
    let blackKing = [];


    function appendFiguresStates(){
      const figuresCopy = JSON.parse(JSON.stringify(figures));
      figuresStates.push(figuresCopy);
    }

    function populateFigures() {

      whitePawns = [];
      whiteRooks = [];
      whiteKnights = [];
      whiteBishops = [];
      whiteQueen = [];
      whiteKing = [];

      blackPawns = [];
      blackRooks = [];
      blackKnights = [];
      blackBishops = [];
      blackQueen = [];
      blackKing = [];
      
      figures.forEach((row, rowIndex) => {
        row.forEach((figure, colIndex) => {
          if (figure === "♟") {
            blackPawns.push(letters[colIndex] + (8 - rowIndex));
          } else if (figure === "♜") {
            blackRooks.push(letters[colIndex] + (8 - rowIndex));
          } else if (figure === "♞") {
            blackKnights.push(letters[colIndex] + (8 - rowIndex));
          } else if (figure === "♝") {
            blackBishops.push(letters[colIndex] + (8 - rowIndex));
          } else if (figure === "♛") {
            blackQueen.push(letters[colIndex] + (8 - rowIndex));
          } else if (figure === "♚") {
            blackKing.push(letters[colIndex] + (8 - rowIndex));
          } else if (figure === "♙") {
            whitePawns.push(letters[colIndex] + (8 - rowIndex));
          } else if (figure === "♖") {
            whiteRooks.push(letters[colIndex] + (8 - rowIndex));
          } else if (figure === "♘") {
            whiteKnights.push(letters[colIndex] + (8 - rowIndex));
          } else if (figure === "♗") {
            whiteBishops.push(letters[colIndex] + (8 - rowIndex));
          } else if (figure === "♕") {
            whiteQueen.push(letters[colIndex] + (8 - rowIndex));
          } else if (figure === "♔") {
            whiteKing.push(letters[colIndex] + (8 - rowIndex));
          }
        });
      });
      appendFiguresStates();
    }

    populateFigures();

    board.append("rect")
      .attr("x", 50)
      .attr("y", 50)
      .attr("width", boardWidth)
      .attr("height", boardWidth)
      .style("fill", "none")
      .style("stroke", "#000")
      .style("stroke-width", "4");

    for (let i = 0; i < 8; i++) {
      const x = i * squareWidth + squareWidth / 2 + 50;
      const y = boardWidth + 50 + 30;
      board.append("text")
        .attr("x", x)
        .attr("y", y)
        .attr("font-family", "Arial")
        .attr("font-size", "20")
        .attr("font-weight", "bold")
        .attr("text-anchor", "middle")
        .text(letters[i]);
    }

    for (let i = 0; i < 8; i++) {
      const x = 50 - 30;
      const y = i * squareWidth + squareWidth / 2 + 50;
      board.append("text")
        .attr("x", x)
        .attr("y", y)
        .attr("text-anchor", "middle")
        .attr("font-family", "Arial")
        .attr("font-size", "20")
        .attr("font-weight", "bold")
        .attr("alignment-baseline", "middle")
        .text(8 - i);
    }

    const innerBoard = board.append("g")
      .attr("transform", "translate(50,50)");

    function drawInnerBoard(index) {
      if(index != -1){
        figures = figuresStates[index]
      }

      innerBoard.selectAll("*").remove();
      for (let i = 0; i < 8; i++) {
        for (let j = 0; j < 8; j++) {
          const x = j * squareWidth;
          const y = i * squareWidth;
          const color = (i + j) % 2 === 0 ? "#fff" : "#C9883E";
          innerBoard.append("rect")
            .attr("x", x)
            .attr("y", y)
            .attr("width", squareWidth)
            .attr("height", squareWidth)
            .attr("id", `${letters[j]}${8 - i}`)
            .style("fill", color);

          if (figures[i][j] !== "") {
            innerBoard.append("text")
              .attr("x", x + squareWidth / 2)
              .attr("y", y + squareWidth / 2 + 10)
              .attr("id", `p-${letters[j]}${8 - i}`)
              .attr("text-anchor", "middle")
              .attr("alignment-baseline", "middle")
              .attr("font-size", "65")
              .text(figures[i][j]);
          }
        }
      }
    }

    drawInnerBoard(-1);

    let moves = [];
    let outcome;

    function convertMovesFormat(movesString) {
      const movesArray = movesString.split(' ');
      let convertedMoves = [];
      for (let i = 0; i < movesArray.length-1; i++) {
        if (movesArray[i].includes(".")){
          convertedMoves.push(movesArray[i].split('.')[1]);
        }
        else{
          convertedMoves.push(movesArray[i]);
        }
      }
      outcome = movesArray[movesArray.length-1];
      return convertedMoves;
    }

    const modal = document.getElementById("myModal");
    const openModalBtn = document.getElementById("openModalBtn");
    const closeBtn = document.getElementsByClassName("close")[0];
    const saveMoveBtn = document.getElementById("saveMoveBtn");
    const moveInput = document.getElementById("moveInput");
    const whiteMovesList = document.getElementById("whiteMovesList");
    const blackMovesList = document.getElementById("blackMovesList");
    const startBtn = document.getElementById("startBtn");

    openModalBtn.onclick = function() {
      modal.style.display = "block";
    }

    closeBtn.onclick = function() {
      modal.style.display = "none";
    }
    
    let functionsToRun = [];

    let stopFlag = false;
    let timeout;

    saveMoveBtn.onclick = function() {
      removeHoverEffect();
      let stopFlag = true;
      clearTimeout(timeout);
      startBtn.innerHTML = "Start";
      moves = [];
      figures = 
        [
          ["♜", "♞", "♝", "♛", "♚", "♝", "♞", "♜"],
          ["♟", "♟", "♟", "♟", "♟", "♟", "♟", "♟"],
          ["", "", "", "", "", "", "", ""],
          ["", "", "", "", "", "", "", ""],
          ["", "", "", "", "", "", "", ""],
          ["", "", "", "", "", "", "", ""],
          ["♙", "♙", "♙", "♙", "♙", "♙", "♙", "♙"],
          ["♖", "♘", "♗", "♕", "♔", "♗", "♘", "♖"]
        ];
      populateFigures();
      drawInnerBoard(-1);
      figuresStates = [];
      whiteMovesList.innerHTML = "";
      blackMovesList.innerHTML = "";
      functionsToRun = [];
      if (movesInput.value.trim() !== "") {
        moves = convertMovesFormat(movesInput.value);
      }

      addMovesToSidebar();
      loadMoves();
    }

    startBtn.onclick = function() {
      removeHoverEffect();
      let stopFlag = true;
      clearTimeout(timeout);
      changeButtonToRestart();
      moves = [];
      figures = 
        [
          ["♜", "♞", "♝", "♛", "♚", "♝", "♞", "♜"],
          ["♟", "♟", "♟", "♟", "♟", "♟", "♟", "♟"],
          ["", "", "", "", "", "", "", ""],
          ["", "", "", "", "", "", "", ""],
          ["", "", "", "", "", "", "", ""],
          ["", "", "", "", "", "", "", ""],
          ["♙", "♙", "♙", "♙", "♙", "♙", "♙", "♙"],
          ["♖", "♘", "♗", "♕", "♔", "♗", "♘", "♖"]
        ];
      populateFigures();
      drawInnerBoard(-1);
      figuresStates = [];
      whiteMovesList.innerHTML = "";
      blackMovesList.innerHTML = "";
      functionsToRun = [];
      if (movesInput.value.trim() !== "") {
        moves = convertMovesFormat(movesInput.value);
      }

      addMovesToSidebar();
      loadMoves();

      runFunctionsInSequenceWithDelay(functionsToRun); 
    }
    let moveElements = [];

    function addMovesToSidebar() {
      whiteMovesList.innerHTML = "";
      blackMovesList.innerHTML = "";

      if (moves.length > 0) {
        moves.forEach((move, index) => {
          const li = document.createElement("li");
          if (index % 2 === 0) {
            const moveIndex = Math.ceil(index / 2) + 1;
            li.textContent = `${moveIndex}. ${move}`;
            whiteMovesList.appendChild(li);
          } else {
            li.textContent = move;
            blackMovesList.appendChild(li);
          }
          moveElements.push({ element: li, index: index });
        });
      }

      const li1 = document.createElement("li");
      if(whiteMovesList.childElementCount !== blackMovesList.childElementCount){
        li1.textContent = "-";
        blackMovesList.appendChild(li1);
      }

      const li2 = document.createElement("li");
      const li3 = document.createElement("li");
      li2.style.fontSize = "24px";
      li3.style.fontSize = "24px";

      if(outcome == "½-½"){
        li2.textContent = "DRAW";
        li3.textContent = "DRAW";
        whiteMovesList.appendChild(li2);
        blackMovesList.appendChild(li3);
      }
      else if(outcome == "1-0"){
        li2.textContent = "VICTORY";
        li3.textContent = "DEFEAT";
        whiteMovesList.appendChild(li2);
        blackMovesList.appendChild(li3);
      }
      else if(outcome == "0-1"){
        li2.textContent = "DEFEAT";
        li3.textContent = "VICTORY";
        whiteMovesList.appendChild(li2);
        blackMovesList.appendChild(li3);
      }
    }

    function addHoverEffect() {
      const moveItems = document.querySelectorAll('li');
      moveItems.forEach(item => {
        const text = item.textContent;
        if (text !== "-" && text !== "DRAW" && text !== "VICTORY" && text !== "DEFEAT") {
          item.classList.add('hover');
        }
      });
    }

    function removeHoverEffect() {
      const moveItems = document.querySelectorAll('li');
      moveItems.forEach(item => {
          item.classList.remove('hover');
      });
    }


    function addEventListeners() {
      moveElements.forEach(move => {
          move.element.addEventListener("click", move.listener = function() {
              drawInnerBoard(move.index);
          });
      });
    }

    var lettersDict = {
      "a":0,
      "b":1,
      "c":2,
      "d":3,
      "e":4,
      "f":5,
      "g":6,
      "h":7,
    };

    var numbersDict = {
      "8":0,
      "7":1,
      "6":2,
      "5":3,
      "4":4,
      "3":5,
      "2":6,
      "1":7,
    };

    function movePawn(move, isWhite) {

      const letter = move[0];
      const number = parseInt(move[1]);
      const targetSquare = `${letter}${number}`;
      const pawns = isWhite ? whitePawns : blackPawns;
      const direction = isWhite ? -1 : 1;

      const singleStepNumber = number + direction;
      const doubleStepNumber = number + 2 * direction;
      
      let possiblePawns = [];

      if (singleStepNumber >= 1 && singleStepNumber <= 8) {
          const singleStepSquare = `${letter}${singleStepNumber}`;
          const singleStepRow = numbersDict[singleStepNumber];
          const singleStepColumn = lettersDict[letter];

          if (figures[numbersDict[number]][lettersDict[letter]] === "" && pawns.includes(singleStepSquare)) {
              possiblePawns.push(singleStepSquare);
          }
      }

      if (doubleStepNumber >= 1 && doubleStepNumber <= 8 && number === (isWhite ? 4 : 5)) {
          const doubleStepSquare = `${letter}${doubleStepNumber}`;
          const doubleStepRow = numbersDict[doubleStepNumber];
          const doubleStepColumn = lettersDict[letter];
          const intermediateRow = numbersDict[number + direction];

          if (figures[numbersDict[number]][lettersDict[letter]] === "" && figures[intermediateRow][doubleStepColumn] === "" && pawns.includes(doubleStepSquare)) {
              possiblePawns.push(doubleStepSquare);
          }
      }

      if (possiblePawns.length === 1) {
          const pawnSquare = possiblePawns[0];
          const currentRow = numbersDict[pawnSquare[1]];
          const currentColumn = lettersDict[pawnSquare[0]];
          const targetRow = numbersDict[number];
          const targetColumn = lettersDict[letter];

          figures[currentRow][currentColumn] = "";
          figures[targetRow][targetColumn] = isWhite ? "♙" : "♟";

          populateFigures();
          updateBoard(pawnSquare, targetSquare);
      } else {
          console.log("No valid moves found.", move);
      }
    }

    function movePawnCaptures(move, isWhite) {

      let [prevSquare, targetSquare] = move.split('x');
      if (prevSquare.length === 2) {
          const specifiedPawn = isWhite ? whitePawns.find(pawn => pawn === prevSquare) : blackPawns.find(pawn => pawn === prevSquare);

          if (specifiedPawn) {

              const prevRow = numbersDict[prevSquare[1]];
              const prevColumn = lettersDict[prevSquare[0]];
              const targetRow = numbersDict[targetSquare[1]];
              const targetColumn = lettersDict[targetSquare[0]];
              
              if(figures[targetRow][targetColumn] == ""){

                figures[prevRow][prevColumn] = "";
                figures[targetRow][targetColumn] = isWhite ? "♙" : "♟";

                populateFigures();
                updateBoardEnPassant(prevSquare, targetSquare, targetSquare[0]+prevSquare[1]);
              }

              else{
                figures[prevRow][prevColumn] = "";
                figures[targetRow][targetColumn] = isWhite ? "♙" : "♟";

                populateFigures();
                updateBoard(prevSquare, targetSquare);
              }
              return;
          }
      }
      if (prevSquare.length === 1) {

          let possiblePawns = isWhite ? whitePawns.filter(pawn => pawn[0] === prevSquare[0]) : blackPawns.filter(pawn => pawn[0] === prevSquare[0]);
          
          possiblePawns.forEach(pawn => {
              if (pawn[1] == parseInt(targetSquare[1]) - 1 || pawn[1] == parseInt(targetSquare[1]) + 1) {
                  prevSquare = pawn;
              }
          });
          if (prevSquare.length == 2) {
            const prevRow = numbersDict[prevSquare[1]];
            const prevColumn = lettersDict[prevSquare[0]];
            const targetRow = numbersDict[targetSquare[1]];
            const targetColumn = lettersDict[targetSquare[0]];

            if(figures[targetRow][targetColumn] == ""){

              figures[prevRow][prevColumn] = "";
              figures[targetRow][targetColumn] = isWhite ? "♙" : "♟";

              populateFigures();
              updateBoardEnPassant(prevSquare, targetSquare, targetSquare[0]+prevSquare[1]);
            }

            else{
              figures[prevRow][prevColumn] = "";
              figures[targetRow][targetColumn] = isWhite ? "♙" : "♟";
            
              populateFigures();
              updateBoard(prevSquare, targetSquare);
            }
            
            return;
          }

        console.log("No valid moves found.", move);
      }   
    }

    function moveRook(move, isWhite) {

      const hasDisambiguation = move.length === 4;
      const disambiguation = hasDisambiguation ? move[1] : null;
      const targetLetter = hasDisambiguation ? move[2] : move[1];
      const targetNumber = parseInt(hasDisambiguation ? move[3] : move[2]);
      const targetSquare = `${targetLetter}${targetNumber}`;
      const rooks = isWhite ? whiteRooks : blackRooks;

      let possibleRooks = [];

      rooks.forEach(rook => {
          const startLetter = rook[0];
          const startNumber = parseInt(rook[1]);
          const startSquare = `${startLetter}${startNumber}`;

          if (hasDisambiguation && disambiguation !== startLetter && parseInt(disambiguation) !== startNumber) {
              return;
          }

          const startRow = numbersDict[startNumber];
          const startColumn = lettersDict[startLetter];
          const targetRow = numbersDict[targetNumber];
          const targetColumn = lettersDict[targetLetter];

          if (startRow === targetRow || startColumn === targetColumn) {
              let isPathClear = true;

              if (startRow === targetRow) {
                  const step = startColumn < targetColumn ? 1 : -1;
                  for (let col = startColumn + step; col !== targetColumn; col += step) {
                      if (figures[startRow][col] !== "") {
                          isPathClear = false;
                          break;
                      }
                  }
              } else {
                  const step = startRow < targetRow ? 1 : -1;
                  for (let row = startRow + step; row !== targetRow; row += step) {
                      if (figures[row][startColumn] !== "") {
                          isPathClear = false;
                          break;
                      }
                  }
              }

              if (isPathClear) {
                  possibleRooks.push(startSquare);
              }
          }
      });

      if (possibleRooks.length === 1) {
          const rookSquare = possibleRooks[0];
          const currentRow = numbersDict[rookSquare[1]];
          const currentColumn = lettersDict[rookSquare[0]];
          const targetRow = numbersDict[targetNumber];
          const targetColumn = lettersDict[targetLetter];

          figures[currentRow][currentColumn] = "";
          figures[targetRow][targetColumn] = isWhite ? "♖" : "♜";

          populateFigures();
          updateBoard(rookSquare, targetSquare);
      } else {
          console.log("No valid moves found.", move);
      }
    }

    function moveBishop(move, isWhite) {

      const hasDisambiguation = move.length === 4;
      const disambiguation = hasDisambiguation ? move[1] : null;
      const targetLetter = hasDisambiguation ? move[2] : move[1];
      const targetNumber = parseInt(hasDisambiguation ? move[3] : move[2]);
      const targetSquare = `${targetLetter}${targetNumber}`;
      const bishops = isWhite ? whiteBishops : blackBishops;

      let possibleBishops = [];

      bishops.forEach(bishop => {
          const startLetter = bishop[0];
          const startNumber = parseInt(bishop[1]);
          const startSquare = `${startLetter}${startNumber}`;

          if (hasDisambiguation && disambiguation !== startLetter && parseInt(disambiguation) !== startNumber) {
              return;
          }

          const startRow = numbersDict[startNumber];
          const startColumn = lettersDict[startLetter];
          const targetRow = numbersDict[targetNumber];
          const targetColumn = lettersDict[targetLetter];

          if (Math.abs(targetRow - startRow) === Math.abs(targetColumn - startColumn)) {
              let isPathClear = true;

              const rowStep = startRow < targetRow ? 1 : -1;
              const colStep = startColumn < targetColumn ? 1 : -1;

              let row = startRow + rowStep;
              let col = startColumn + colStep;

              while (row !== targetRow && col !== targetColumn) {
                  if (figures[row][col] !== "") {
                      isPathClear = false;
                      break;
                  }
                  row += rowStep;
                  col += colStep;
              }

              if (isPathClear) {
                  possibleBishops.push(startSquare);
              }
          }
      });

      if (possibleBishops.length === 1) {
          const bishopSquare = possibleBishops[0];
          const currentRow = numbersDict[bishopSquare[1]];
          const currentColumn = lettersDict[bishopSquare[0]];
          const targetRow = numbersDict[targetNumber];
          const targetColumn = lettersDict[targetLetter];

          figures[currentRow][currentColumn] = "";
          figures[targetRow][targetColumn] = isWhite ? "♗" : "♝";

          populateFigures();
          updateBoard(bishopSquare, targetSquare);
      } else {
          console.log("No valid moves found.", move);
      }
    }

    function moveKnight(move, isWhite) {

      const hasDisambiguation = move.length === 4;
      const disambiguation = hasDisambiguation ? move[1] : null;
      const targetLetter = hasDisambiguation ? move[2] : move[1];
      const targetNumber = parseInt(hasDisambiguation ? move[3] : move[2]);
      const targetSquare = `${targetLetter}${targetNumber}`;
      const knights = isWhite ? whiteKnights : blackKnights;

      let possibleKnights = [];

      knights.forEach(knight => {
          const startLetter = knight[0];
          const startNumber = parseInt(knight[1]);
          const startSquare = `${startLetter}${startNumber}`;

          if (hasDisambiguation && disambiguation !== startLetter && parseInt(disambiguation) !== startNumber) {
              return;
          }

          const startRow = numbersDict[startNumber];
          const startColumn = lettersDict[startLetter];
          const targetRow = numbersDict[targetNumber];
          const targetColumn = lettersDict[targetLetter];

          const rowDiff = Math.abs(targetRow - startRow);
          const colDiff = Math.abs(targetColumn - startColumn);
          if ((rowDiff === 1 && colDiff === 2) || (rowDiff === 2 && colDiff === 1)) {
              possibleKnights.push(startSquare);
          }
      });

      if (possibleKnights.length === 1) {
          const knightSquare = possibleKnights[0];
          const currentRow = numbersDict[knightSquare[1]];
          const currentColumn = lettersDict[knightSquare[0]];
          const targetRow = numbersDict[targetNumber];
          const targetColumn = lettersDict[targetLetter];

          figures[currentRow][currentColumn] = "";
          figures[targetRow][targetColumn] = isWhite ? "♘" : "♞";

          populateFigures();
          updateBoard(knightSquare, targetSquare);
      } else {
          console.log("No valid moves found.", move);
      }
    }

    function moveQueen(move, isWhite) {

      const hasDisambiguation = move.length === 4;
      const disambiguation = hasDisambiguation ? move[1] : null;
      const targetLetter = hasDisambiguation ? move[2] : move[1];
      const targetNumber = parseInt(hasDisambiguation ? move[3] : move[2]);
      const targetSquare = `${targetLetter}${targetNumber}`;
      const queens = isWhite ? whiteQueen : blackQueen;

      let possibleQueens = [];

      queens.forEach(queen => {
          const startLetter = queen[0];
          const startNumber = parseInt(queen[1]);
          const startSquare = `${startLetter}${startNumber}`;

          if (hasDisambiguation && disambiguation !== startLetter && parseInt(disambiguation) !== startNumber) {
              return;
          }

          const startRow = numbersDict[startNumber];
          const startColumn = lettersDict[startLetter];
          const targetRow = numbersDict[targetNumber];
          const targetColumn = lettersDict[targetLetter];

          if (
              startRow === targetRow ||
              startColumn === targetColumn ||
              Math.abs(targetRow - startRow) === Math.abs(targetColumn - startColumn)
          ) {
              let isPathClear = true;

              if (startRow === targetRow) {
                  const step = startColumn < targetColumn ? 1 : -1;
                  for (let col = startColumn + step; col !== targetColumn; col += step) {
                      if (figures[startRow][col] !== "") {
                          isPathClear = false;
                          break;
                      }
                  }
              } else if (startColumn === targetColumn) {
                  const step = startRow < targetRow ? 1 : -1;
                  for (let row = startRow + step; row !== targetRow; row += step) {
                      if (figures[row][startColumn] !== "") {
                          isPathClear = false;
                          break;
                      }
                  }
              } else {
                  const rowStep = startRow < targetRow ? 1 : -1;
                  const colStep = startColumn < targetColumn ? 1 : -1;
                  let row = startRow + rowStep;
                  let col = startColumn + colStep;
                  while (row !== targetRow && col !== targetColumn) {
                      if (figures[row][col] !== "") {
                          isPathClear = false;
                          break;
                      }
                      row += rowStep;
                      col += colStep;
                  }
              }

              if (isPathClear) {
                  possibleQueens.push(startSquare);
              }
          }
      });

      if (possibleQueens.length == 1) {
          const queenSquare = possibleQueens[0];
          const currentRow = numbersDict[queenSquare[1]];
          const currentColumn = lettersDict[queenSquare[0]];
          const targetRow = numbersDict[targetNumber];
          const targetColumn = lettersDict[targetLetter];

          figures[currentRow][currentColumn] = "";
          figures[targetRow][targetColumn] = isWhite ? "♕" : "♛";

          populateFigures();
          updateBoard(queenSquare, targetSquare);
      } else {
          console.log("No valid moves found.", move);
      }
    }

    function moveKing(move, isWhite) {

      const targetLetter = move[1];
      const targetNumber = parseInt(move[2]);
      const targetSquare = `${targetLetter}${targetNumber}`;
      const king = isWhite ? whiteKing[0] : blackKing[0]; 

      const startLetter = king[0];
      const startNumber = parseInt(king[1]);
      const startSquare = `${startLetter}${startNumber}`;

      const startRow = numbersDict[startNumber];
      const startColumn = lettersDict[startLetter];
      const targetRow = numbersDict[targetNumber];
      const targetColumn = lettersDict[targetLetter];

      if (
          Math.abs(targetRow - startRow) <= 1 &&
          Math.abs(targetColumn - startColumn) <= 1
      ) {

          figures[startRow][startColumn] = "";
          figures[targetRow][targetColumn] = isWhite ? "♔" : "♚";

          populateFigures();
          updateBoard(startSquare, targetSquare);
      } else {
          console.log("No valid moves found.", move);
      }
    }

    function castleKingSide(isWhite) {

      const kingRow = isWhite ? 7 : 0;
      const rookRow = isWhite ? 7 : 0;
      const kingStartColumn = 4;
      const kingEndColumn = 6;
      const rookStartColumn = 7;
      const rookEndColumn = 5;

      for (let col = kingStartColumn + 1; col < kingEndColumn; col++) {
        if (figures[kingRow][col] !== "") {
          console.log("No valid moves found.", move);
          return;
        }
      }

      figures[kingRow][kingStartColumn] = "";
      figures[kingRow][kingEndColumn] = isWhite ? "♔" : "♚";
      
      figures[rookRow][rookStartColumn] = "";
      figures[rookRow][rookEndColumn] = isWhite ? "♖" : "♜";

      populateFigures();
      updateBoard(`${letters[kingStartColumn]}${8 - kingRow}`, `${letters[kingEndColumn]}${8 - kingRow}`);
      updateBoard(`${letters[rookStartColumn]}${8 - rookRow}`, `${letters[rookEndColumn]}${8 - rookRow}`);
    }

    function castleQueenSide(isWhite) {

      const kingRow = isWhite ? 7 : 0;
      const rookRow = isWhite ? 7 : 0;
      const kingStartColumn = 4;
      const kingEndColumn = 2;
      const rookStartColumn = 0;
      const rookEndColumn = 3;

      for (let col = kingStartColumn - 1; col > kingEndColumn; col--) {
        if (figures[kingRow][col] !== "") {
          console.log("No valid moves found.", move);
          return;
        }
      }

      figures[kingRow][kingStartColumn] = "";
      figures[kingRow][kingEndColumn] = isWhite ? "♔" : "♚";

      figures[rookRow][rookStartColumn] = "";
      figures[rookRow][rookEndColumn] = isWhite ? "♖" : "♜";
      
      populateFigures();
      updateBoard(`${letters[kingStartColumn]}${8 - kingRow}`, `${letters[kingEndColumn]}${8 - kingRow}`);
      updateBoard(`${letters[rookStartColumn]}${8 - rookRow}`, `${letters[rookEndColumn]}${8 - rookRow}`);
    }

    function movePiece(move, isWhite) {

      const pieceType = move[0];
      const fromSquare = move.slice(1, 3);
      const toSquare = move.slice(3, 5);

      const fromLetter = fromSquare[0];
      const fromNumber = parseInt(fromSquare[1]);
      const toLetter = toSquare[0];
      const toNumber = parseInt(toSquare[1]);

      const fromRow = numbersDict[fromNumber];
      const fromColumn = lettersDict[fromLetter];
      const toRow = numbersDict[toNumber];
      const toColumn = lettersDict[toLetter];

      const pieceMap = {
          'R': isWhite ? '♖' : '♜',
          'N': isWhite ? '♘' : '♞',
          'B': isWhite ? '♗' : '♝',
          'Q': isWhite ? '♕' : '♛',
      };

      const pieceSymbol = pieceMap[pieceType];

      figures[fromRow][fromColumn] = "";
      figures[toRow][toColumn] = pieceSymbol;

      populateFigures();
      updateBoard(fromSquare, toSquare);
    }

    function promotePawn(move, isWhite) {

      const promotionInfo = move.slice(-4);
      const promoteToPiece = promotionInfo[3];
      let pieceUnicode;
      
      if (promoteToPiece == 'Q'){
        pieceUnicode = isWhite ? '♕' : '♛';
      }

      else if (promoteToPiece == 'R'){
        pieceUnicode = isWhite ? '♖' : '♜';
      }

      else if (promoteToPiece == 'B'){
        pieceUnicode = isWhite ? '♗' : '♝';
      }

      else {
        pieceUnicode = isWhite ? '♘' : '♞';
      }

      const targetSquare = promotionInfo.slice(0, 2);
      const targetRow = numbersDict[targetSquare[1]];
      const targetColumn = lettersDict[targetSquare[0]];
      figures[targetRow][targetColumn] = pieceUnicode;
      figuresStates.pop();
      populateFigures();
      updateBoardPromotePawn(targetSquare, pieceUnicode);
    }

    function updateBoard(from, to) {

      const piece = d3.select(`#p-${from}`);
      const removePiece = d3.select(`#p-${to}`);
      const startSquare = d3.select(`#${from}`);
      const targetSquare = d3.select(`#${to}`);

      const startPos = startSquare.node().getBoundingClientRect();
      const targetPos = targetSquare.node().getBoundingClientRect();

      let newX = parseFloat(piece.attr("x")) + (targetPos.left - startPos.left);
      let newY = parseFloat(piece.attr("y")) + (targetPos.top - startPos.top);


      piece.raise();
      piece.transition()
          .duration(200)
          .attr("x",newX)
          .attr("y",newY)
          .attr("id", `p-${to}`)
          .on("end", function() {
              removePiece.remove();
          });
    }

    function updateBoardEnPassant(from, to, remove) {

      const piece = d3.select(`#p-${from}`);
      const removePiece = d3.select(`#p-${remove}`);
      const startSquare = d3.select(`#${from}`);
      const targetSquare = d3.select(`#${to}`);

      const startPos = startSquare.node().getBoundingClientRect();
      const targetPos = targetSquare.node().getBoundingClientRect();

      let newX = parseFloat(piece.attr("x")) + (targetPos.left - startPos.left);
      let newY = parseFloat(piece.attr("y")) + (targetPos.top - startPos.top);


      piece.raise();
      piece.transition()
          .duration(200)
          .attr("x",newX)
          .attr("y",newY)
          .attr("id", `p-${to}`)
          .on("end", function() {
              removePiece.remove();
          });
    }
    
    function updateBoardPromotePawn(from, to){

      const piece = d3.select(`#p-${from}`);
      piece.transition()
          .duration(200)
          .text(to)
    }

    function removeSpecialCharacters(move) {
      return move.replace(/[+#]/g, '');
    }

    function removeXCharacter(move) {
      return move.replace('x', '');
    }
    
    function changeButtonToRestart(){
      startBtn.innerHTML = "Restart";   
    }       

    function runFunctionsInSequenceWithDelay(functions, index = 0, delay = 400) {
      if (index < functions.length && !stopFlag) {
        timeout = setTimeout(() => {
          functions[index]();
          runFunctionsInSequenceWithDelay(functions, index + 1, delay);
        }, delay);
      }
    }
    
    function loadMoves(){

      for (let i = 0; i < moves.length; i++) {

          const move = removeSpecialCharacters(moves[i]);
          
          const isWhite = i%2 === 0 ? true : false;

          if (move === "O-O") {
              functionsToRun.push(() => castleKingSide(isWhite));
          }

          else if (move === "O-O-O") {
              functionsToRun.push(() => castleQueenSide(isWhite));
          }
          
          else if (move[0] === "N") {
              if (removeXCharacter(move).length === 5){
                  functionsToRun.push(() => movePiece(removeXCharacter(move), isWhite));

              } else{
                  functionsToRun.push(() => moveKnight(removeXCharacter(move), isWhite));
              }
              

          } else if (move[0] === "B") {
            if (removeXCharacter(move).length === 5){
                  functionsToRun.push(() => movePiece(removeXCharacter(move), isWhite));

            } else{
                  functionsToRun.push(() => moveBishop(removeXCharacter(move), isWhite));
            }
                
            
          } else if (move[0] === "R") {
            if (removeXCharacter(move).length === 5){
                  functionsToRun.push(() => movePiece(removeXCharacter(move), isWhite));

            } else{
                  functionsToRun.push(() => moveRook(removeXCharacter(move), isWhite));
            }

          } else if (move[0] === "Q") {
            if (removeXCharacter(move).length === 5){
                  functionsToRun.push(() => movePiece(removeXCharacter(move), isWhite));

            } else{
              functionsToRun.push(() => moveQueen(removeXCharacter(move), isWhite));
            }
          } else if (move[0] === "K") {
              functionsToRun.push(() => moveKing(removeXCharacter(move), isWhite));
            
          } else {
              if (move.includes("x")){
                if (move.includes("=")) {
                  const moveParts = move.split('=');
                  functionsToRun.push(() => movePawnCaptures(moveParts[0], isWhite));
                  functionsToRun.push(() => promotePawn(move, isWhite));
                } else {
                  functionsToRun.push(() => movePawnCaptures(move, isWhite));
                }
            
              } else{
                  if (move.includes("=")) {
                      const moveParts = move.split('=');
                      functionsToRun.push(() => movePawn(moveParts[0], isWhite));
                      functionsToRun.push(() => promotePawn(move, isWhite));
                    } else {
                      functionsToRun.push(() => movePawn(move, isWhite));
                    }
              }   
          }            
      }
      functionsToRun.push(() => addEventListeners());
      functionsToRun.push(() => changeButtonToRestart());
      functionsToRun.push(() => addHoverEffect());
    }
    
  </script>
  </body>
</html>
